import { IChassisContext, IChassisDataStore, IOperation } from "../interfaces";
import { CRUDMiddleware } from "./CRUDMiddleware";
/*************************************************************************
 *
 * Troven CONFIDENTIAL
 * __________________
 *
 *  (c) 2017-2020 Troven Ventures Pty Ltd. All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Troven Pty Ltd and its licensors,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Troven Pty Ltd
 * and its suppliers and may be covered by International and Regional Patents,
 * patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Troven Pty Ltd.
 */
export declare class NestedTreeStore implements IChassisDataStore {
    name: string;
    store: IChassisDataStore;
    id_field_name: string;
    collection_field_name: string;
    options: any;
    context: IChassisContext;
    constructor();
    getIDField(): string;
    getCollectionField(): string;
    getStoreMiddleware(): CRUDMiddleware;
    install(context: IChassisContext, options: any): this;
    redact(meta: any): any;
    nestedCallback(oper: IOperation, meta: any, req_options: any, options: any, callback: Function): (err: any, items: any) => void;
    healthy(req_options: any, callback: Function): void;
    query(oper: IOperation, meta: any, req_options: any, options: any, callback: Function): void;
    create(oper: IOperation, meta: any, req_options: any, options: any, callback: Function): void;
    read(oper: IOperation, meta: any, req_options: any, options: any, callback: Function): void;
    list(oper: IOperation, meta: any, req_options: any, options: any, callback: Function): void;
    update(oper: IOperation, meta: any, req_options: any, options: any, callback: Function): void;
    delete(oper: IOperation, meta: any, req_options: any, options: any, callback: Function): void;
}
