import { IChassisContext, IOperation } from "../interfaces";
export default class APIs {
    static DEBUG: boolean;
    constructor();
    static get(_context: IChassisContext, _url: string): Promise<any>;
    static request(context: IChassisContext, url: string, _headers: any): Promise<any>;
    static named_request(context: IChassisContext, api_name: string, url: string, _headers: any): Promise<any>;
    /**
     * Collect a set of API responses as promise
     *
     * @param apis
     * @param params
     * @param token
     */
    static requests(context: IChassisContext, apis: APIRequests, params: any, token?: string): Promise<APIResponses>;
    static getOperationContext(_op: IOperation, req: any, _ctx?: any): APIContext;
    static getRequestContext(req: any, _ctx?: any): APIContext;
}
export interface APIRequests {
    [name: string]: APIRequest;
}
export interface APIRequest {
    url: string;
    headers?: any;
}
export interface APIResponses {
    [name: string]: any;
}
export interface APIContext {
    req: any;
    op: any;
    jwt: any;
    params: any;
    query: any;
}
