export default class GQL {
    static schema_to_gql_types: {
        "string": string;
    };
    json_schemas: any;
    gql_types: any;
    constructor(_schemas?: any);
    schemas(_schemas: any): void;
    types(): any;
    /**
     * sanitize `txt` by converting to lower case and replacing non-alpha with `_` (underscore)
     * @param txt
     */
    static $(txt: string): string;
    /**
     * construct a named GraphQL query from the schema
     *
     * @param name
     * @param schema
     */
    static query(name: string, schema: any): string;
    /**
     * return ! if `name` is a required field within schema
     *
     * @param name
     * @param schema
     */
    static is_required(name: string, schema: any): boolean;
    /**
     * return GraphQL type definition (schema)
     *
     * @param name
     * @param schema
     */
    static to_type(name: string, schema: any): string;
    static to_type_properties(root: any, schema: any): any;
    /**
     * create argument list for parameters
     *
     * @param args
     */
    static to_args(args?: any): string;
    /**
     * construct a query fragment from the named schema
     *
     * @param name
     * @param schema
     * @param args
     */
    static to_query(name: string, schema: any, args?: any): any;
}
