import { IChassisContext, IJWT } from "../index";
export default class JWT {
    static getHeaders(token: string, headers?: any): any;
    static getBearerToken(context: IChassisContext, req: any): any;
    static getJWT(context: IChassisContext, req: any, res?: any): any;
    static getValidJWT(context: IChassisContext, req: any, res?: any): any;
    /**
     * Check for internal consistency within the JWT
     *  not expiry date/time
     *  not before valid date/time
     *
     * @param context
     * @param jwt
     * @param res
     */
    sanityCheckOrSendError(context: IChassisContext, jwt: IJWT, res?: any): boolean;
    static getBearerTokenOrSendError(context: IChassisContext, req: any, res?: any): any;
    /**
     * JWT must contain a non-empty `subject`.
     * If claims are empty or not specified, then we return true
     * Otherwise,
     * @param jwt
     * @param claims
     */
    static hasClaims(jwt: any, claims?: any, context?: IChassisContext): boolean;
}
