"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Ajv = require("ajv");
const _ = require("lodash");
class Validator {
    constructor(schema) {
        this.schema = schema;
    }
    validate(data, ref_id_or_ref) {
        let schemas = _.values(this.schema.schemas);
        let validator = new Ajv({ schemas: schemas });
        if (validator.validate(ref_id_or_ref, data)) {
            return true;
        }
        return validator.errors;
    }
}
exports.Validator = Validator;
//# sourceMappingURL=Validator.js.map