"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _ = require("lodash");
const middleware_1 = require("../middleware");
/**
 * plugin has configs the 'graphql' middleware
 *
 * @param context
 * @param options
 * @returns {exports}
 */
class graphql_plugin {
    constructor() {
        this.name = "graphql";
        this.title = "Configure graphql middleware";
    }
    install(_context, _options) {
        // global proxy options for graphql
        this.options = _.extend({ proxy: {} }, _options);
        _context.middleware.set(new middleware_1.graphql(this));
        _context.log({ code: "api:plugin:graphql", options: this.options });
    }
}
exports.default = graphql_plugin;
//# sourceMappingURL=graphql.js.map