/*************************************************************************
 *
 * Troven CONFIDENTIAL
 * __________________
 *
 *  (c) 2017-2020 Troven Ventures Pty Ltd
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Troven Pty Ltd and its licensors,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Troven Pty Ltd
 * and its suppliers and may be covered by International and Regional Patents,
 * patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Troven Pty Ltd.
 */
import { IChassisContext, IChassisPlugin } from "../interfaces";
import { OpenAPI, Paths, Operation } from "../openapi/";
import { Router } from "express";
import { PipelinePlugin } from "./pipeline";
import JWTPlugin from "./jwt";
/**
 * openapi
 * ---------
 * Used when a method is not found
 *
 * @type {{name: string, title: string, fn: module.exports.fn}}
 */
export default class openapi implements IChassisPlugin {
    name: string;
    title: string;
    openapi: OpenAPI;
    context: IChassisContext;
    api: Router;
    pipeline: PipelinePlugin;
    jwt: JWTPlugin;
    install(context: IChassisContext, options: any): void;
    reset(): void;
    route_paths(paths: Paths): Router;
    route(op: Operation): Function;
}
