"use strict";
/*************************************************************************
 *
 * Troven CONFIDENTIAL
 * __________________
 *
 *  (c) 2017-2020 Troven Ventures Pty Ltd
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Troven Pty Ltd and its licensors,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Troven Pty Ltd
 * and its suppliers and may be covered by International and Regional Patents,
 * patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Troven Pty Ltd.
 */
Object.defineProperty(exports, "__esModule", { value: true });
const _ = require("lodash");
/**
 * secrets
 * ---------
 * Used when a method is not found
 *
 * @type {{name: string, title: string, fn: module.exports.fn}}
 */
class SecretsPlugin {
    constructor() {
        this.name = "secrets";
        this.title = "ENV-based secrets";
    }
    install(_context) {
        let options = _.extend({ "unlockKey": "" }, _context.config.secrets);
        _context.secrets = new SimpleSecrets(options, options.unlockKey);
    }
}
exports.default = SecretsPlugin;
class SimpleSecrets {
    constructor(options, unlockKey) {
        this.options = options;
        unlockKey && this.unlock(unlockKey);
    }
    unlock(_ignored) {
    }
    get(name) {
        return new Promise((resolve, rejects) => {
            let _secret = process.env[name];
            _secret ? resolve(_secret) : rejects();
        });
    }
}
//# sourceMappingURL=secrets.js.map