
import { IChassisExtension } from "../interfaces";

/**
 * Generic "feature" registry to manage ChassisPlugins and ChassisOperations.
 *
 */
export class Registry<T extends IChassisExtension> {
    features: any = {};

    constructor() {
    }

    set(feature: T): T {
        this.features[feature.name] = feature;
        return feature;
    }

    get(name: string): T {
        return this.features[name];
    }
}