/*************************************************************************
 *
 * Troven CONFIDENTIAL
 * __________________
 *
 *  (c) 2017-2020 Troven Ventures Pty Ltd
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Troven Pty Ltd and its licensors,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Troven Pty Ltd
 * and its suppliers and may be covered by International and Regional Patents,
 * patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Troven Pty Ltd.
 */


import * as _ from "lodash";
import {IOperation, IChassisContext, IChassisFeature  } from "../index";
import * as express from "express";
import assert = require("assert");

/**
 * bower_components
 * ----------------
 * Serve static assets from ./bower_components/
 *
 * @type {{name: string, title: string, description: string, fn: module.exports.fn}}
 */
export default class bower_components implements IChassisFeature {

    name = "api.bower_components";
    title = "serve bower components on an endpoint";

    fn(operation: IOperation, options: any): Function {
        let context: IChassisContext = operation.context;

        assert(context, "missing context");
        
        let cwd = process.cwd();
        let static_options = _.extend({ redirect: false }, options);

        return express.static( cwd + 'bower_components', static_options);
    }

};