/*************************************************************************
 *
 * Troven CONFIDENTIAL
 * __________________
 *
 *  (c) 2017-2020 Troven Ventures Pty Ltd
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Troven Pty Ltd and its licensors,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Troven Pty Ltd
 * and its suppliers and may be covered by International and Regional Patents,
 * patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Troven Pty Ltd.
 */

import * as _ from "lodash";
import {IOperation, IChassisFeature} from "../interfaces";

/**
 * Mock Endpoint
 * ----------
 * Feature adds an X-CHASSIS method that reports the chassis name and port.
 *
 * @type {{name: string, title: string, description: string, fn: module.exports.fn}}
 */

export default class mock implements IChassisFeature {
    name = "api.mock";
    title = "Mock endpoint";

    fn(operation: IOperation, options: any): Function {
        false && operation;
        false && options;

        let mock = { mock: true };

        return function(req: any, res: any, next: any ){
            false && req;
            res.send(mock);
            next();
        };
    }

}