
import * as Ajv from "ajv";
import * as _ from "lodash";
import { Schemas } from "./Schemas";

export class Validator {

    constructor(protected schema: Schemas) {
    }

    validate(data: any, ref_id_or_ref: string): any {
        let schemas = _.values( this.schema.schemas );
        let validator = new Ajv( { schemas: schemas } );
        if ( validator.validate(ref_id_or_ref, data) ) {
            return true;
        }
        return validator.errors;
    }

}
