

import {IChassisContext, IChassisPlugin } from "../index";
import * as _ from "lodash";
import { graphql } from "../middleware";

/**
 * plugin has configs the 'graphql' middleware
 *
 * @param context
 * @param options
 * @returns {exports}
 */
export default class graphql_plugin implements IChassisPlugin {

    name = "graphql";
    title = "Configure graphql middleware";

    options: any;

    install(_context: IChassisContext, _options: any) {

        // global proxy options for graphql
        this.options = _.extend({ proxy: {} } , _options);

        _context.middleware.set( new graphql(this) );

        _context.log({ code: "api:plugin:graphql", options: this.options });
}

}